#include <iostream>

#include <omp.h>

using namespace std;

class par_perceptron
{
    public:
        par_perceptron();
		
		//Creates a perceptron with the given number of inputs and stores the pointer to the weights.
        par_perceptron(int numInputs, float * weights);
		
		//Creates a perceptron with the same m_numInputs as target
		//	Does NOT copy the weights or inputs
        par_perceptron& operator=(const par_perceptron & target);
		
        ~par_perceptron();
        
		
		//Sets the pointer to the perceptron's inputs to the "data" parameter
		void set_inputs(float * data);
		
		//Sets the pointer to the perceptron's inputs to the "data" parameter
		//Sets the number of inputs to the "numInputs" patameter
        void set_inputs(int numInputs, float * data);
		
		
		//Sets the pointer to the weights of the inputs to the "weights" parameter
        void set_weights(float * weights);
        
		//Sets the contents of m_output to 1 if the threshold is met, 0 if not.
		void process();

        float * m_output;
        
        void set_numInputs(int numInputs);

    private:
        int m_numInputs;
        float * m_inputs;
        float * m_weights;
};

#include "par_perceptron.hpp"
